%==========================================================================
% read boxfile
%==========================================================================

%==========================================================================
% small tuning parameters
%==========================================================================

mul=1;      % multiply field values by this factor

%==========================================================================

figure
maxval=0.0;

fpt=fopen('../MODELS/boxfile','r');

for i=1:14
    fgets(fpt);
end

p.pp=fscanf(fpt,'%i',1);
p.px=fscanf(fpt,'%i',1);
p.py=fscanf(fpt,'%i',1);
p.pz=fscanf(fpt,'%i',1);

fgets(fpt);
fgets(fpt);

p.mi=[1:p.pp];
p.mi_theta=[1:p.pp];
p.mi_phi=[1:p.pp];
p.mi_r=[1:p.pp];

p.itheta_min=[1:p.pp];
p.itheta_max=[1:p.pp];
p.iphi_min=[1:p.pp];
p.iphi_max=[1:p.pp];
p.ir_min=[1:p.pp];
p.ir_max=[1:p.pp];

p.theta_min=[1:p.pp];
p.theta_max=[1:p.pp];
p.phi_min=[1:p.pp];
p.phi_max=[1:p.pp];
p.r_min=[1:p.pp];
p.r_max=[1:p.pp];

for i=1:p.pp
    
    p.mi(i)=fscanf(fpt,'%d',1);
    p.mi_theta(i)=fscanf(fpt,'%d',1);
    p.mi_phi(i)=fscanf(fpt,'%d',1);
    p.mi_z(i)=fscanf(fpt,'%d',1);
    p.itheta_min(i)=fscanf(fpt,'%i',1);
    p.itheta_max(i)=fscanf(fpt,'%i',1);
    p.iphi_min(i)=fscanf(fpt,'%i',1);
    p.iphi_max(i)=fscanf(fpt,'%i',1);
    p.ir_min(i)=fscanf(fpt,'%i',1);
    p.ir_max(i)=fscanf(fpt,'%i',1);
    
    p.theta_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.theta_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.r_min(i)=fscanf(fpt,'%lf',1);
    p.r_max(i)=fscanf(fpt,'%lf',1);
    
    fgets(fpt);
    fgets(fpt);
    
end

fclose(fpt);

%==========================================================================
% determine filename
%==========================================================================

n=input('processor vector: ');
plane=input('plane (x (theta), y (phi), z (r)): ','s');
comp=input('component (x (theta), y (phi), z (r)): ', 's');
it=input('iteration: ');

if (strcmp(plane,'x'))
   theta=input('theta [deg]: ');
   theta=theta*pi/180;
end

plot_radii=input('plot radii (km): ');

%==========================================================================
% successively open files
%==========================================================================

for index=1:length(n)

   filename=['../DATA/OUTPUT/slice_' plane '_u' comp '_' num2str(n(index)) '_' num2str(it)];
   fpt=fopen(filename,'r');

   fprintf(1,'opening file %s\n',filename);

   %==========================================================================
   % load coordinate lines
   %==========================================================================

   filename_xco=['../DATA/COORDINATES/xco_' num2str(n(index))];
   filename_yco=['../DATA/COORDINATES/yco_' num2str(n(index))];
   filename_zco=['../DATA/COORDINATES/zco_' num2str(n(index))];

   fid_xco=fopen(filename_xco,'r');
   fid_yco=fopen(filename_yco,'r');
   fid_zco=fopen(filename_zco,'r');

   xco=fscanf(fid_xco,'%f',inf);
   yco=fscanf(fid_yco,'%f',inf);
   zco=fscanf(fid_zco,'%f',inf);

   x_min=min(xco);
   x_max=max(xco);
   y_min=min(yco);
   y_max=max(yco);
   z_min=min(zco);
   z_max=max(zco);


   if (index==1)

      x_min_global=min(xco);
      x_max_global=max(xco);
      y_min_global=min(yco);
      y_max_global=max(yco);
      z_min_global=min(zco);
      z_max_global=max(zco);

   else

      if (min(xco)<x_min_global) x_min_global=min(xco); end
      if (max(xco)>x_max_global) x_max_global=max(xco); end
      if (min(yco)<y_min_global) y_min_global=min(yco); end
      if (max(yco)>y_max_global) y_max_global=max(yco); end
      if (min(zco)<z_min_global) z_min_global=min(zco); end
      if (max(zco)>z_max_global) z_max_global=max(zco); end

   end


   fclose(fid_xco);
   fclose(fid_yco);
   fclose(fid_zco);

   
   %==========================================================================
   % read and plot fields
   %==========================================================================

   if (strcmp(plane,'x'))
    
       field=zeros(length(yco),length(zco));
    
       for k=1:length(zco)
           for j=1:length(yco)
               field(j,k)=mul*fscanf(fpt,'%f',1);
           end
       end
    
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
       
       [yco,zco]=meshgrid(yco,zco);
				
       y=zco.*sin(yco).*sin(theta);
       z=zco.*cos(yco);

       pcolor(y,z,field');
       shading interp
       hold on
       axis off
       
       for i=1:length(plot_radii)
           if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))
       
                if (z_min==min(plot_radii))
    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'-');
                    
                elseif (z_max==max(plot_radii))
                    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'+');
                    
                else
                    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'0');
                    
                end
               
           end     
       end
       
   end

   if (strcmp(plane,'y'))
    
       field=zeros(length(xco),length(zco));
    
       for k=1:length(zco)
           for i=1:length(xco)
               field(i,k)=mul*fscanf(fpt,'%f',1);
           end
       end
    
       
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
       
       [xco,zco]=meshgrid(xco,zco);

       x=zco.*cos(xco);
       z=zco.*sin(xco);
       
       pcolor(x,z,field');
       shading interp
       hold on
       axis off
       
       
       for i=1:length(plot_radii)
           if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))
       
                if (z_min==min(plot_radii))
    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'-');
                    
                elseif (z_max==max(plot_radii))
                    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'+');
                    
                else
                    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'0');
                    
                end
               
           end     
       end
      
   end

   if (strcmp(plane,'z'))
    
       field=zeros(length(xco),length(yco));
    
       for j=1:length(yco)
           for i=1:length(xco)
               field(i,j)=mul*fscanf(fpt,'%f',1);
           end
       end
    
       
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
       
       [xco,yco]=meshgrid(xco,yco);
       pcolor(xco,yco,field');
       hold on
    
       xlabel('x [m]');
       ylabel('y [m]');
       axis([x_min x_max y_min y_max]);
    
   end

   fclose(fpt);

end

%=========================================================================
% plot left and right boundary lines
%=========================================================================

if (strcmp(plane,'x'))
 
    line([sin(y_min_global)*z_max_global sin(y_min_global)*z_min_global],[cos(y_min_global)*z_max_global cos(y_min_global)*z_min_global],'Color',[0 0 0]);
    line([sin(y_max_global)*z_max_global sin(y_max_global)*z_min_global],[cos(y_max_global)*z_max_global cos(y_max_global)*z_min_global],'Color',[0 0 0]);

end    

if (strcmp(plane,'y'))
 
    line([sin(x_min_global)*z_max_global sin(x_min_global)*z_min_global],[cos(x_min_global)*z_max_global cos(x_min_global)*z_min_global],'Color',[0 0 0]);
    line([sin(x_max_global)*z_max_global sin(x_max_global)*z_min_global],[cos(x_max_global)*z_max_global cos(x_max_global)*z_min_global],'Color',[0 0 0]);

end    

axis image

cm=[  0         0    0.5625
    0.0312    0.0312    0.5762
    0.0625    0.0625    0.5898
    0.0938    0.0938    0.6035
    0.1250    0.1250    0.6172
    0.1562    0.1562    0.6309
    0.1875    0.1875    0.6445
    0.2188    0.2188    0.6582
    0.2500    0.2500    0.6719
    0.2812    0.2812    0.6855
    0.3125    0.3125    0.6992
    0.3438    0.3438    0.7129
    0.3750    0.3750    0.7266
    0.4062    0.4062    0.7402
    0.4375    0.4375    0.7539
    0.4688    0.4688    0.7676
    0.5000    0.5000    0.7812
    0.5312    0.5312    0.7949
    0.5625    0.5625    0.8086
    0.5938    0.5938    0.8223
    0.6250    0.6250    0.8359
    0.6562    0.6562    0.8496
    0.6875    0.6875    0.8633
    0.7188    0.7188    0.8770
    0.7500    0.7500    0.8906
    0.7812    0.7812    0.9043
    0.8125    0.8125    0.9180
    0.8438    0.8438    0.9316
    0.8750    0.8750    0.9453
    0.9062    0.9062    0.9590
    0.9375    0.9375    0.9727
    0.9688    0.9688    0.9863
    1.0000    1.0000    1.0000
    0.9953    0.9677    0.9677
    0.9906    0.9355    0.9355
    0.9860    0.9032    0.9032
    0.9813    0.8710    0.8710
    0.9766    0.8387    0.8387
    0.9719    0.8065    0.8065
    0.9673    0.7742    0.7742
    0.9626    0.7419    0.7419
    0.9579    0.7097    0.7097
    0.9532    0.6774    0.6774
    0.9485    0.6452    0.6452
    0.9439    0.6129    0.6129
    0.9392    0.5806    0.5806
    0.9345    0.5484    0.5484
    0.9298    0.5161    0.5161
    0.9252    0.4839    0.4839
    0.9205    0.4516    0.4516
    0.9158    0.4194    0.4194
    0.9111    0.3871    0.3871
    0.9065    0.3548    0.3548
    0.9018    0.3226    0.3226
    0.8971    0.2903    0.2903
    0.8924    0.2581    0.2581
    0.8877    0.2258    0.2258
    0.8831    0.1935    0.1935
    0.8784    0.1613    0.1613
    0.8737    0.1290    0.1290
    0.8690    0.0968    0.0968
    0.8644    0.0645    0.0645
    0.8597    0.0323    0.0323
    0.8550         0         0];

%colormap(cm);
%caxis([-maxval maxval]);