%==========================================================================
% small tuning parameters and paths
%==========================================================================

mul=1;      % multiply field values by this factor
path(path,'/home/fichtner/mmap/m_map');

min_lon=120.0;
max_lon=185.0;
min_lat=-45.0;
max_lat=5.0;

%min_lon=139.5;
%max_lon=146.0;
%min_lat=-6.0;
%max_lat=6.0;

%==========================================================================
% read boxfile
%==========================================================================

figure
maxval=0.0;

fpt=fopen('../MODELS/boxfile','r');

for i=1:14
    fgets(fpt);
end

p.pp=fscanf(fpt,'%i',1);
p.px=fscanf(fpt,'%i',1);
p.py=fscanf(fpt,'%i',1);
p.pz=fscanf(fpt,'%i',1);

fgets(fpt);
fgets(fpt);

p.mi=[1:p.pp];
p.mi_theta=[1:p.pp];
p.mi_phi=[1:p.pp];
p.mi_r=[1:p.pp];

p.itheta_min=[1:p.pp];
p.itheta_max=[1:p.pp];
p.iphi_min=[1:p.pp];
p.iphi_max=[1:p.pp];
p.ir_min=[1:p.pp];
p.ir_max=[1:p.pp];

p.theta_min=[1:p.pp];
p.theta_max=[1:p.pp];
p.phi_min=[1:p.pp];
p.phi_max=[1:p.pp];
p.r_min=[1:p.pp];
p.r_max=[1:p.pp];

for i=1:p.pp
    
    p.mi(i)=fscanf(fpt,'%d',1);
    p.mi_theta(i)=fscanf(fpt,'%d',1);
    p.mi_phi(i)=fscanf(fpt,'%d',1);
    p.mi_z(i)=fscanf(fpt,'%d',1);
    p.itheta_min(i)=fscanf(fpt,'%i',1);
    p.itheta_max(i)=fscanf(fpt,'%i',1);
    p.iphi_min(i)=fscanf(fpt,'%i',1);
    p.iphi_max(i)=fscanf(fpt,'%i',1);
    p.ir_min(i)=fscanf(fpt,'%i',1);
    p.ir_max(i)=fscanf(fpt,'%i',1);
    
    p.theta_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.theta_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.r_min(i)=fscanf(fpt,'%lf',1);
    p.r_max(i)=fscanf(fpt,'%lf',1);
    
    fgets(fpt);
    fgets(fpt);
    
end

fclose(fpt);

%==========================================================================
% determine filename
%==========================================================================

n=input('processor vector: ');
plane=input('plane (x (theta), y (phi), z (r)): ','s');
comp=input('parameter (rho, cp, cs): ', 's');

if (strcmp(plane,'z'))
    
    m_proj('mercator','longitudes',[min_lon max_lon],'latitudes',[min_lat max_lat]);
    
end

if (strcmp(plane,'x'))
   theta=input('theta [deg]: ');
   theta=theta*pi/180;
end

if (strcmp(comp,'rho'))
    
    comp='rhoinv';
    
end

if (strcmp(plane,'x') | strcmp(plane,'y'))

    plot_radii=input('plot radii (km): ');
    plot_radii=1000*plot_radii;
    
end

%==========================================================================
% successively open files
%==========================================================================

for index=1:length(n)

   filename_rho=['../MODELS/slice_' plane '_rhoinv' num2str(n(index))];
   filename_lambda=['../MODELS/slice_' plane '_mu' num2str(n(index))];
   filename_mu=['../MODELS/slice_' plane '_lambda' num2str(n(index))];
   fpt_rho=fopen(filename_rho,'r');
   fpt_lambda=fopen(filename_mu,'r');
   fpt_mu=fopen(filename_lambda,'r');

   fprintf(1,'opening file %s\n',filename_rho);
   fprintf(1,'opening file %s\n',filename_lambda);
   fprintf(1,'opening file %s\n',filename_mu);

   %==========================================================================
   % load coordinate lines
   %==========================================================================

   filename_xco=['../DATA/COORDINATES/xco_' num2str(n(index))];
   filename_yco=['../DATA/COORDINATES/yco_' num2str(n(index))];
   filename_zco=['../DATA/COORDINATES/zco_' num2str(n(index))];

   fid_xco=fopen(filename_xco,'r');
   fid_yco=fopen(filename_yco,'r');
   fid_zco=fopen(filename_zco,'r');

   xco=fscanf(fid_xco,'%f',inf);
   yco=fscanf(fid_yco,'%f',inf);
   zco=fscanf(fid_zco,'%f',inf);

   x_min=min(xco);
   x_max=max(xco);
   y_min=min(yco);
   y_max=max(yco);
   z_min=min(zco);
   z_max=max(zco);


   if (index==1)

      x_min_global=min(xco);
      x_max_global=max(xco);
      y_min_global=min(yco);
      y_max_global=max(yco);
      z_min_global=min(zco);
      z_max_global=max(zco);

   else

      if (min(xco)<x_min_global) x_min_global=min(xco); end
      if (max(xco)>x_max_global) x_max_global=max(xco); end
      if (min(yco)<y_min_global) y_min_global=min(yco); end
      if (max(yco)>y_max_global) y_max_global=max(yco); end
      if (min(zco)<z_min_global) z_min_global=min(zco); end
      if (max(zco)>z_max_global) z_max_global=max(zco); end

   end


   fclose(fid_xco);
   fclose(fid_yco);
   fclose(fid_zco);

   
   %==========================================================================
   % read and plot fields
   %==========================================================================

   if (strcmp(plane,'x'))
    
       rhoinv=zeros(length(yco),length(zco));
       lambda=zeros(length(yco),length(zco));
       mu=zeros(length(yco),length(zco));
    
       for k=1:length(zco)
           for j=1:length(yco)
               rhoinv(j,k)=mul*fscanf(fpt_rho,'%f',1);
               lambda(j,k)=mul*fscanf(fpt_lambda,'%f',1);
               mu(j,k)=mul*fscanf(fpt_mu,'%f',1);
           end
       end
    
       if (strcmp(comp,'rhoinv'))
       
            field=1./rhoinv;
            
       elseif (strcmp(comp,'cs'))
           
           field=sqrt(mu.*rhoinv);
           
       elseif (strcmp(comp,'cp'))
           
           field=sqrt((2*mu+lambda).*rhoinv);
           
       end
       
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
          
       [yco,zco]=meshgrid(yco,zco);
				
       y=zco.*cos(yco);
       z=zco.*sin(yco);

       pcolor(y,z,field');
       shading flat
       hold on
       axis off
       
       for i=1:length(plot_radii)
           if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))
       
                if (z_min==min(plot_radii))
    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'-');
                    
                elseif (z_max==max(plot_radii))
                    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'+');
                    
                else
                    
                    plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'0');
                    
                end
               
           end     
       end
       
   end

   if (strcmp(plane,'y'))
    
       rhoinv=zeros(length(xco),length(zco));
       lambda=zeros(length(xco),length(zco));
       mu=zeros(length(xco),length(zco));
    
       for k=1:length(zco)
           for i=1:length(xco)
               rhoinv(i,k)=mul*fscanf(fpt_rho,'%f',1);
               lambda(i,k)=mul*fscanf(fpt_lambda,'%f',1);
               mu(i,k)=mul*fscanf(fpt_mu,'%f',1);
           end
       end
    
       
       if (strcmp(comp,'rhoinv'))
       
            field=1./rhoinv;
            
       elseif (strcmp(comp,'cs'))
           
           field=sqrt(mu.*rhoinv);
           
       elseif (strcmp(comp,'cp'))
           
           field=sqrt((2*mu+lambda).*rhoinv);
           
       end
       
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
       
       [xco,zco]=meshgrid(xco,zco);

       x=zco.*cos(xco);
       z=zco.*sin(xco);
       
       pcolor(x,z,field');
       hold on
       shading flat
       axis off
       
       %figure
       
       for i=1:length(plot_radii)
           if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))
       
                if (z_min==min(plot_radii))
    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'-');
                    
                elseif (z_max==max(plot_radii))
                    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'+');
                    
                else
                    
                    plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'0');
                    
                end
               
           end     
       end
      
   end

   if (strcmp(plane,'z'))
    
       rhoinv=zeros(length(xco),length(yco));
       lambda=zeros(length(xco),length(yco));
       mu=zeros(length(xco),length(yco));
    
       for j=1:length(yco)
           for i=1:length(xco)
               rhoinv(i,j)=mul*fscanf(fpt_rho,'%f',1);
               lambda(i,j)=mul*fscanf(fpt_lambda,'%f',1);
               mu(i,j)=mul*fscanf(fpt_mu,'%f',1);
           end
       end
    
       
       if (strcmp(comp,'rhoinv'))
       
            field=1./rhoinv;
            
       elseif (strcmp(comp,'cs'))
           
           
           field=sqrt(mu.*rhoinv);
           %field=mu;
           
       elseif (strcmp(comp,'cp'))
           
           field=sqrt((2*mu+lambda).*rhoinv);
           
       end
       
       if (maxval<max(max(abs(field))))
           
           maxval=max(max(abs(field)));
           
       end
       
       [lat,lon]=meshgrid(90-xco*180/pi,yco*180/pi);
       m_pcolor(lon,lat,field');
       shading interp %flat
       hold on
     
   end
   
   fclose(fpt_rho);
   fclose(fpt_lambda);
   fclose(fpt_mu);

end

%=========================================================================
% plot left and right boundary lines
%=========================================================================

if (strcmp(plane,'x'))
 
    line([sin(y_min_global)*z_max_global sin(y_min_global)*z_min_global],[cos(y_min_global)*z_max_global cos(y_min_global)*z_min_global],'Color',[0 0 0]);
    line([sin(y_max_global)*z_max_global sin(y_max_global)*z_min_global],[cos(y_max_global)*z_max_global cos(y_max_global)*z_min_global],'Color',[0 0 0]);

end    

%figure

%if (strcmp(plane,'y'))
 
%    line([sin(x_min_global)*z_max_global sin(x_min_global)*z_min_global],[cos(x_min_global)*z_max_global cos(x_min_global)*z_min_global],'Color',[0 0 0]);
%    line([sin(x_max_global)*z_max_global sin(x_max_global)*z_min_global],[cos(x_max_global)*z_max_global cos(x_max_global)*z_min_global],'Color',[0 0 0]);

%end    

if (strcmp(plane,'z'))

    m_coast('patch',[0.8 0.85 0.8],'edgecolor','k','FaceAlpha',0.2);
    m_grid('box','fancy','linestyle','none');

end


axis image

load colormap_maps
colormap(m);
%caxis([-maxval/10 maxval/10]);