%==========================================================================
% read boxfile
%==========================================================================

close all
clear

addpath /l1/heiner/Bin

%==========================================================================
% small tuning parameters
%==========================================================================

mul=1;      % multiply field values by this factor
fac=.1;

%==========================================================================

figure


fpt=fopen('../MODELS/boxfile','r');

for i=1:14
    fgets(fpt);
end

p.pp=fscanf(fpt,'%i',1);
p.px=fscanf(fpt,'%i',1);
p.py=fscanf(fpt,'%i',1);
p.pz=fscanf(fpt,'%i',1);

fgets(fpt);
fgets(fpt);

p.mi=[1:p.pp];
p.mi_theta=[1:p.pp];
p.mi_phi=[1:p.pp];
p.mi_r=[1:p.pp];

p.itheta_min=[1:p.pp];
p.itheta_max=[1:p.pp];
p.iphi_min=[1:p.pp];
p.iphi_max=[1:p.pp];
p.ir_min=[1:p.pp];
p.ir_max=[1:p.pp];

p.theta_min=[1:p.pp];
p.theta_max=[1:p.pp];
p.phi_min=[1:p.pp];
p.phi_max=[1:p.pp];
p.r_min=[1:p.pp];
p.r_max=[1:p.pp];

for i=1:p.pp

    p.mi(i)=fscanf(fpt,'%d',1);
    p.mi_theta(i)=fscanf(fpt,'%d',1);
    p.mi_phi(i)=fscanf(fpt,'%d',1);
    p.mi_z(i)=fscanf(fpt,'%d',1);
    p.itheta_min(i)=fscanf(fpt,'%i',1);
    p.itheta_max(i)=fscanf(fpt,'%i',1);
    p.iphi_min(i)=fscanf(fpt,'%i',1);
    p.iphi_max(i)=fscanf(fpt,'%i',1);
    p.ir_min(i)=fscanf(fpt,'%i',1);
    p.ir_max(i)=fscanf(fpt,'%i',1);

    p.theta_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.theta_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_min(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.phi_max(i)=fscanf(fpt,'%lf',1)*180/pi;
    p.r_min(i)=fscanf(fpt,'%lf',1);
    p.r_max(i)=fscanf(fpt,'%lf',1);

    fgets(fpt);
    fgets(fpt);

end

fclose(fpt);

%==========================================================================
% determine filename
%==========================================================================

%n=input('processor vector: ');
n=[14 20 2 26 32 38 44 50 56 62 68 8];
%plane=input('plane (x (theta), y (phi), z (r)): ','s');
plane='x';
%comp=input('component (x (theta), y (phi), z (r)): ', 's');


for ic=2:2,
    if ic==1,comp='x';end
    if ic==2,comp='y';end
    if ic==3,comp='z';end


    maxval=0.0;[14 20 2 26 32 38 44 50 56 62 68 8]
    %it=input('iteration: ');

    isnap=0;

    for it=50:50:1500,

        isnap=isnap+1;

        if (strcmp(plane,'x'))
            %theta=input('theta [deg]: ');
            theta=90;
            theta=theta*pi/180;
        end

        %plot_radii=input('plot radii (km): ');
        plot_radii=6371;
        maxval=0.0;
        %==========================================================================
        % successively open files
        %==========================================================================

        for index=1:length(n)

            filename=['../DATA/OUTPUT/slice_' plane '_u' comp '_' num2str(n(index)) '_' num2str(it)];
            fpt=fopen(filename,'r');

            fprintf(1,'opening file %s\n',filename);

            %==========================================================================
            % load coordinate lines
            %==========================================================================

            filename_xco=['../DATA/COORDINATES/xco_' num2str(n(index))];
            filename_yco=['../DATA/COORDINATES/yco_' num2str(n(index))];
            filename_zco=['../DATA/COORDINATES/zco_' num2str(n(index))];

            fid_xco=fopen(filename_xco,'r');
            fid_yco=fopen(filename_yco,'r');
            fid_zco=fopen(filename_zco,'r');

            xco=fscanf(fid_xco,'%f',inf);
            yco=fscanf(fid_yco,'%f',inf);
            zco=fscanf(fid_zco,'%f',inf);

            x_min=min(xco);
            x_max=max(xco);
            y_min=min(yco);
            y_max=max(yco);
            z_min=min(zco);
            z_max=max(zco);


            if (index==1)

                x_min_global=min(xco);
                x_max_global=max(xco);
                y_min_global=min(yco);
                y_max_global=max(yco);
                z_min_global=min(zco);
                z_max_global=max(zco);

            else

                if (min(xco)<x_min_global) x_min_global=min(xco); end
                if (max(xco)>x_max_global) x_max_global=max(xco); end
                if (min(yco)<y_min_global) y_min_global=min(yco); end
                if (max(yco)>y_max_global) y_max_global=max(yco); end
                if (min(zco)<z_min_global) z_min_global=min(zco); end
                if (max(zco)>z_max_global) z_max_global=max(zco); end

            end


            fclose(fid_xco);
            fclose(fid_yco);
            fclose(fid_zco);


            %==========================================================================
            % read and plot fields
            %==========================================================================

            if (strcmp(plane,'x'))

                field=zeros(length(yco),length(zco));

                for k=1:length(zco)
                    for j=1:length(yco)
                        field(j,k)=mul*fscanf(fpt,'%f',1);
                    end
                end

                if (maxval<max(max(abs(field))))

                    maxval=max(max(abs(field)));

                end

                [yco,zco]=meshgrid(yco,zco);

                y=zco.*sin(yco).*sin(theta);
                z=zco.*cos(yco);

                mycolormap('fichtner');
                pcolor(y,z,field');
                title(sprintf(' it = %i ',it));
                shading interp
                hold on
                %axis off

                for i=1:length(plot_radii)
                    if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))

                        if (z_min==min(plot_radii))

                            plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'-');

                        elseif (z_max==max(plot_radii))

                            plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'+');

                        else

                            plotaxis(y_min,y_max,plot_radii(i),plot_radii(i)+0.01,'0');

                        end

                    end
                end

            end

            if (strcmp(plane,'y'))

                field=zeros(length(xco),length(zco));

                for k=1:length(zco)
                    for i=1:length(xco)
                        field(i,k)=mul*fscanf(fpt,'%f',1);
                    end
                end


                if (maxval<max(max(abs(field))))

                    maxval=max(max(abs(field)));

                end

                [xco,zco]=meshgrid(xco,zco);

                x=zco.*cos(xco);
                z=zco.*sin(xco);

                pcolor(x,z,field');
                shading interp
                hold on
                axis off


                for i=1:length(plot_radii)
                    if ((z_max>=plot_radii(i)) & (z_min<=plot_radii(i)))

                        if (z_min==min(plot_radii))

                            plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'-');

                        elseif (z_max==max(plot_radii))

                            plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'+');

                        else

                            plotaxis(x_min,x_max,plot_radii(i),plot_radii(i)+0.01,'0');

                        end

                    end
                end

            end

            if (strcmp(plane,'z'))

                field=zeros(length(xco),length(yco));

                for j=1:length(yco)
                    for i=1:length(xco)
                        field(i,j)=mul*fscanf(fpt,'%f',1);
                    end
                end


               if (maxval<max(max(abs(field))))

                    maxval=max(max(abs(field)));

               end

                mycolormap('fichtner')
                [xco,yco]=meshgrid(xco,yco);
                pcolor(xco/pi*180,yco/pi*180,field');
                shading  interp
                caxis([-maxval maxval])
                title(sprintf(' %s-component ',comp))
                hold on

                xlabel('theta [deg]');
                ylabel('phi [deg]');
                axis([x_min x_max y_min y_max]);

            end

            fclose(fpt);

        end

        %=========================================================================
        % plot left and right boundary lines
        %=========================================================================

        if (strcmp(plane,'x'))

            line([sin(y_min_global)*z_max_global sin(y_min_global)*z_min_global],[cos(y_min_global)*z_max_global cos(y_min_global)*z_min_global],'Color',[0 0 0]);
            line([sin(y_max_global)*z_max_global sin(y_max_global)*z_min_global],[cos(y_max_global)*z_max_global cos(y_max_global)*z_min_global],'Color',[0 0 0]);

        end

        if (strcmp(plane,'y'))

            line([sin(x_min_global)*z_max_global sin(x_min_global)*z_min_global],[cos(x_min_global)*z_max_global cos(x_min_global)*z_min_global],'Color',[0 0 0]);
            line([sin(x_max_global)*z_max_global sin(x_max_global)*z_min_global],[cos(x_max_global)*z_max_global cos(x_max_global)*z_min_global],'Color',[0 0 0]);

        end

        axis image
        caxis([-fac*maxval fac*maxval])

        if ic==1, Mx(isnap)=getframe; end
        if ic==2, My(isnap)=getframe; end
        if ic==3, Mz(isnap)=getframe; end


    end

end

%colormap(cm);
caxis([-.01*maxval .01*maxval]);