subroutine prem_iso_no_ocean
use variables_new
implicit none
include 'mpif.h'
		
	!=============================================================
	! PREM isotropic (without ocean but with crust)
	!=============================================================
		
	if (my_rank==0) then

		write(*,*) 'PREM without ocean'

        endif

        !- allocate memory

        allocate(cp1d(0:nz_loc,0:lpd))
        allocate(cs1d(0:nz_loc,0:lpd))
        allocate(rho1d(0:nz_loc,0:lpd))
        allocate(r(0:nz_loc,0:lpd))
                    
        !- make 1D model

        r=z/6371e3

        do i=0,nz_loc
        	do k=0,lpd

			!- crust
		
			if ((z(i,k)<=6371000) .and. (z(i,k)>=6356000)) then
				  
			     rho1d(i,k)=2.60
			     cp1d(i,k)=5.80
			     cs1d(i,k)=3.20
			     
			elseif ((z(i,k)<=6356000) .and. (z(i,k)>=6346600)) then
				  
			     rho1d(i,k)=2.90
			     cp1d(i,k)=6.80
			     cs1d(i,k)=3.90
		       
                        !- LID

                        elseif ((z(i,k)<=6346600) .and. (z(i,k)>=6291000)) then
                             
                             rho1d(i,k)=2.6910+0.6924*r(i,k)
                             cp1d(i,k)=4.1875+3.9382*r(i,k)
                             cs1d(i,k)=2.1519+2.3481*r(i,k)

                        !- LVZ

                        elseif((z(i,k)<=6291000) .and. (z(i,k)>=6151000)) then

                             rho1d(i,k)=2.6910+0.6924*r(i,k)
                             cp1d(i,k)=4.1875+3.9382*r(i,k)
                             cs1d(i,k)=2.1519+2.3481*r(i,k)

                        !- Transition zone

                        elseif((z(i,k)<=6151000) .and. (z(i,k)>=5971000)) then

                             rho1d(i,k)=7.1089-3.8045*r(i,k)
                             cp1d(i,k)=20.3926-12.2569*r(i,k)
                             cs1d(i,k)=8.9496-4.4597*r(i,k)

                        elseif((z(i,k)<=5971000) .and. (z(i,k)>=5771000)) then

                             rho1d(i,k)=11.2494-8.0298*r(i,k)
                             cp1d(i,k)=39.7027-32.6166*r(i,k)
                             cs1d(i,k)=22.3512-18.5856*r(i,k)

                        elseif((z(i,k)<=5771000) .and. (z(i,k)>=5701000)) then

                             rho1d(i,k)=5.3197-1.4836*r(i,k)
                             cp1d(i,k)=19.0957-9.8672*r(i,k)
                             cs1d(i,k)=9.9839-4.9324*r(i,k)

                        !- Lower mantle

                        elseif((z(i,k)<=5701000) .and. (z(i,k)>=5600000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=29.2766-23.6026*r(i,k)+5.5242*r(i,k)*r(i,k)-2.5514*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=22.3459-17.2473*r(i,k)-2.0834*r(i,k)*r(i,k)+0.9783*r(i,k)*r(i,k)*r(i,k)

                        elseif((z(i,k)<=5600000) .and. (z(i,k)>=3630000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=24.9520-40.4673*r(i,k)+51.4832*r(i,k)*r(i,k)-26.6419*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=11.1671-13.7818*r(i,k)+17.4575*r(i,k)*r(i,k)-9.2777*r(i,k)*r(i,k)*r(i,k)

                        elseif((z(i,k)<=3630000) .and. (z(i,k)>=3480000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=15.3891-5.3181*r(i,k)+5.5242*r(i,k)*r(i,k)-2.5514*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=6.9254+1.4672*r(i,k)-2.0834*r(i,k)*r(i,k)+0.9783*r(i,k)*r(i,k)*r(i,k)

                        !- Outer core

                        elseif((z(i,k)<=3480000) .and. (z(i,k)>=1221500)) then

                             rho1d(i,k)=12.5815-1.2638*r(i,k)-3.6426*r(i,k)*r(i,k)-5.5281*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=11.0487-4.0362*r(i,k)+4.8023*r(i,k)*r(i,k)-13.5732*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=0.0

                        !- Inner core

                        elseif(z(i,k)<=1221500) then

                             rho1d(i,k)=13.0885-8.8381*r(i,k)*r(i,k)
                             cp1d(i,k)=11.2622-6.3640*r(i,k)*r(i,k)
                             cs1d(i,k)=3.6678-4.4475*r(i,k)*r(i,k)

                        endif

		enddo

            enddo

            rho1d=1000.0*rho1d
            cp1d=1000.0*cp1d
            cs1d=1000.0*cs1d

            !- translate to 3D arrays

            do i=0,nz_loc
               do k=0,lpd

                  rhoinv(:,:,i,:,:,k)=1/rho1d(i,k)
                  mu(:,:,i,:,:,k)=cs1d(i,k)*cs1d(i,k)*rho1d(i,k)
                  lambda(:,:,i,:,:,k)=(cp1d(i,k)*cp1d(i,k)-2*cs1d(i,k)*cs1d(i,k))*rho1d(i,k)

               enddo
            enddo

                    !- clean up

            deallocate(cp1d)
            deallocate(cs1d)
            deallocate(rho1d)
            deallocate(r)
                  
end subroutine prem_iso_no_ocean
