subroutine prem_iso_hetero1
use variables_new
implicit none
include 'mpif.h'
		
	!=============================================================
	! PREM isotropic + heterogeneous
	!=============================================================
	
	!- local variables ----------------------------------------------------
	
	real, dimension(0:nx_loc,0:ny_loc,0:nz_loc,0:lpd,0:lpd,0:lpd) :: pert

	
	if (my_rank==0) then

		write(*,*) 'PREM without ocean'

        endif

        !- allocate memory ----------------------------------------------------

        allocate(cp1d(0:nz_loc,0:lpd))
        allocate(cs1d(0:nz_loc,0:lpd))
        allocate(rho1d(0:nz_loc,0:lpd))
        allocate(r(0:nz_loc,0:lpd))
                    
        !- make 1D model ------------------------------------------------------

        r=z/6371e3

        do i=0,nz_loc
        	do k=0,lpd

			!- LID	
		
                        if ((z(i,k)<=6371000) .and. (z(i,k)>=6291000)) then
                             
                             rho1d(i,k)=2.6910+0.6924*r(i,k)
                             cp1d(i,k)=4.1875+3.9382*r(i,k)
                             cs1d(i,k)=2.1519+2.3481*r(i,k)

                        !- LVZ

                        elseif((z(i,k)<=6291000) .and. (z(i,k)>=6151000)) then

                             rho1d(i,k)=2.6910+0.6924*r(i,k)
                             cp1d(i,k)=4.1875+3.9382*r(i,k)
                             cs1d(i,k)=2.1519+2.3481*r(i,k)

                        !- Transition zone

                        elseif((z(i,k)<=6151000) .and. (z(i,k)>=5971000)) then

                             rho1d(i,k)=7.1089-3.8045*r(i,k)
                             cp1d(i,k)=20.3926-12.2569*r(i,k)
                             cs1d(i,k)=8.9496-4.4597*r(i,k)

                        elseif((z(i,k)<=5971000) .and. (z(i,k)>=5771000)) then

                             rho1d(i,k)=11.2494-8.0298*r(i,k)
                             cp1d(i,k)=39.7027-32.6166*r(i,k)
                             cs1d(i,k)=22.3512-18.5856*r(i,k)

                        elseif((z(i,k)<=5771000) .and. (z(i,k)>=5701000)) then

                             rho1d(i,k)=5.3197-1.4836*r(i,k)
                             cp1d(i,k)=19.0957-9.8672*r(i,k)
                             cs1d(i,k)=9.9839-4.9324*r(i,k)

                        !- Lower mantle

                        elseif((z(i,k)<=5701000) .and. (z(i,k)>=5600000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=29.2766-23.6026*r(i,k)+5.5242*r(i,k)*r(i,k)-2.5514*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=22.3459-17.2473*r(i,k)-2.0834*r(i,k)*r(i,k)+0.9783*r(i,k)*r(i,k)*r(i,k)

                        elseif((z(i,k)<=5600000) .and. (z(i,k)>=3630000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=24.9520-40.4673*r(i,k)+51.4832*r(i,k)*r(i,k)-26.6419*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=11.1671-13.7818*r(i,k)+17.4575*r(i,k)*r(i,k)-9.2777*r(i,k)*r(i,k)*r(i,k)

                        elseif((z(i,k)<=3630000) .and. (z(i,k)>=3480000)) then

                             rho1d(i,k)=7.9565-6.4761*r(i,k)+5.5283*r(i,k)*r(i,k)-3.0807*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=15.3891-5.3181*r(i,k)+5.5242*r(i,k)*r(i,k)-2.5514*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=6.9254+1.4672*r(i,k)-2.0834*r(i,k)*r(i,k)+0.9783*r(i,k)*r(i,k)*r(i,k)

                        !- Outer core

                        elseif((z(i,k)<=3480000) .and. (z(i,k)>=1221500)) then

                             rho1d(i,k)=12.5815-1.2638*r(i,k)-3.6426*r(i,k)*r(i,k)-5.5281*r(i,k)*r(i,k)*r(i,k)
                             cp1d(i,k)=11.0487-4.0362*r(i,k)+4.8023*r(i,k)*r(i,k)-13.5732*r(i,k)*r(i,k)*r(i,k)
                             cs1d(i,k)=0.0

                        !- Inner core

                        elseif(z(i,k)<=1221500) then

                             rho1d(i,k)=13.0885-8.8381*r(i,k)*r(i,k)
                             cp1d(i,k)=11.2622-6.3640*r(i,k)*r(i,k)
                             cs1d(i,k)=3.6678-4.4475*r(i,k)*r(i,k)

                        endif

		enddo

            enddo

            rho1d=1000.0*rho1d
            cp1d=1000.0*cp1d
            cs1d=1000.0*cs1d

	    !- correct crust --------------------------------------------------
	    
	    pert=5*cos(95*XX*pi/180)*sin(95*YY*pi/180)/100;
	    
	    if ((x_min_loc<pi/2) .and. (z_max_loc>6370e3)) then
		   
		    rho1d(0,0)=3200.0
	    	    rho1d(0,1)=3226.0
		    rho1d(0,2)=3286.0
		    rho1d(0,3)=3367.0
		    rho1d(0,4)=3408.0
		    rho1d(0,5)=3390.0
		    rho1d(0,6)=3380.0
		    
	    	    cp1d(0,0)=6600.0
		    cp1d(0,1)=6611.0
		    cp1d(0,2)=7001.0
		    cp1d(0,3)=7789.0
		    cp1d(0,4)=8296.0
		    cp1d(0,5)=8218.0
		    cp1d(0,6)=8109.0
		    
		    cs1d(0,0)=3800.0
		    cs1d(0,1)=3832.0
		    cs1d(0,2)=4024.0
		    cs1d(0,3)=4350.0
		    cs1d(0,4)=4556.0
		    cs1d(0,5)=4528.0
		    cs1d(0,6)=4490.0
		    
		    !rho1d(0,0:lpd)=3200.0
	    	    !cp1d(0,0:lpd)=6600.0
		    !cs1d(0,0:lpd)=3800.0
		    
	    elseif (z_max_loc>6370e3) then
		    
		    rho1d(0,0)=2600.0
	    	    rho1d(0,1)=2650.0
		    rho1d(0,2)=2740.0
		    rho1d(0,3)=2850.0
		    rho1d(0,4)=2930.0
		    rho1d(0,5)=2930.0
		    rho1d(0,6)=2900.0
		    
	    	    cp1d(0,0)=6000.0
		    cp1d(0,1)=5980.0
		    cp1d(0,2)=6170.0
		    cp1d(0,3)=6550.0
		    cp1d(0,4)=6790.0
		    cp1d(0,5)=6750.0
		    cp1d(0,6)=6700.0
		    
		    cs1d(0,0)=3460.0
		    cs1d(0,1)=3490.0
		    cs1d(0,2)=3600.0
		    cs1d(0,3)=3770.0
		    cs1d(0,4)=3890.0
		    cs1d(0,5)=3880.0
		    cs1d(0,6)=3870.0
		    
		    !rho1d(0,0:lpd)=2600.0
	    	    !cp1d(0,0:lpd)=6000.0
		    !cs1d(0,0:lpd)=3460.0
		    
		    !rho1d(1:2,0:lpd)=2900.0
	    	    !cp1d(1:2,0:lpd)=6700.0
		    !cs1d(1:2,0:lpd)=3870.0
		    
	    endif
	    
            !- translate to 3D arrays -----------------------------------------

            do i=0,nz_loc
               do k=0,lpd

                  rhoinv(:,:,i,:,:,k)=1/rho1d(i,k)
                  mu(:,:,i,:,:,k)=cs1d(i,k)*cs1d(i,k)*rho1d(i,k)
                  lambda(:,:,i,:,:,k)=(cp1d(i,k)*cp1d(i,k)-2*cs1d(i,k)*cs1d(i,k))*rho1d(i,k)

               enddo
            enddo
	    
	    !- add heterogeneity ----------------------------------------------
	    
	    if ((x_min_loc>=pi/2) .and. (z_max_loc>6370e3)) then
		    
		    mu(:,:,0,:,:,0:lpd)=mu(:,:,0,:,:,0:lpd)*(1+pert(:,:,0,:,:,0:lpd))*(1+pert(:,:,0,:,:,0:lpd))
	    
	    endif
	    
	    
            !- clean up

            deallocate(cp1d)
            deallocate(cs1d)
            deallocate(rho1d)
            deallocate(r)
                  
end subroutine prem_iso_hetero1
