subroutine spice_tottori
use variables_new
implicit none
real inc
include 'mpif.h'
		
	!=============================================================
	! SPICE Tottori kinematic benchmark
	!=============================================================
		
	if (my_rank==0) then

		write(*,*) 'SPICE Tottori 1D '

        endif

        !- allocate memory

        allocate(cp1d(0:nz_loc,0:lpd))
        allocate(cs1d(0:nz_loc,0:lpd))
        allocate(rho1d(0:nz_loc,0:lpd))
        allocate(r(0:nz_loc,0:lpd))
                    
        !- make 1D model

        r=z/6371e3

        do i=0,nz_loc
        	do k=0,lpd

			!- crust
		
			if ((z(i,k)<=6371000) .and. (z(i,k)>=6369000)) then
				  
		             inc=(6371000-z(i,k))/(6371000-6369000)
			     rho1d(i,k)=2.60 + (2.70 - 2.60) * inc
			     cp1d(i,k)=5.50  + (6.05 - 5.50) * inc
			     cs1d(i,k)=3.18  + (3.50 - 3.18) * inc
			     
			elseif ((z(i,k)<=6369000) .and. (z(i,k)>=6355000)) then

		             inc=(6369000-z(i,k))/(6369000-6355000)				  
			     rho1d(i,k)=2.70 +  (2.80 - 2.70) * inc
			     cp1d(i,k)=6.05 +   (6.60 - 6.05) * inc
			     cs1d(i,k)=3.50 +   (3.81 - 3.50) * inc
		       
                        elseif ((z(i,k)<=6355000) .and. (z(i,k)>=6333000)) then
                             
		             inc=(6355000-z(i,k))/(6355000-6333000)				  
                             rho1d(i,k)=2.8 + (3.10 - 2.80) * inc
                             cp1d(i,k)=6.60 + (8.03 - 6.60) * inc
                             cs1d(i,k)=3.81 + (4.62 - 3.81) * inc

                        elseif(z(i,k)<=6333000) then

                             rho1d(i,k)=3.1
                             cp1d(i,k)=8.03
                             cs1d(i,k)=4.62

                        endif

		enddo

            enddo

            rho1d=1000.0*rho1d
            cp1d=1000.0*cp1d
            cs1d=1000.0*cs1d

            !- translate to 3D arrays

            do i=0,nz_loc
               do k=0,lpd

                  rhoinv(:,:,i,:,:,k)=1/rho1d(i,k)
                  mu(:,:,i,:,:,k)=cs1d(i,k)*cs1d(i,k)*rho1d(i,k)
                  lambda(:,:,i,:,:,k)=(cp1d(i,k)*cp1d(i,k)-2*cs1d(i,k)*cs1d(i,k))*rho1d(i,k)

               enddo
            enddo

                    !- clean up

            deallocate(cp1d)
            deallocate(cs1d)
            deallocate(rho1d)
            deallocate(r)
                  
end subroutine spice_tottori
